package jdwang.hadoop;

import java.io.IOException;
import java.util.*;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

public class Mapper_SumByMonth extends Mapper <Object, Text, Text, IntWritable>{
	
  	public void map(Object key, Text value, Context context
                  ) throws IOException, InterruptedException {
	    	                  
	    // The goals of this study##69##5##(2011-1#4)(2011-10#8)(2011-11#6)(2011-12#7)(2011-2#6)(2011-3#3)(2011-4#5)(2011-5#5)(2011-6#6)(2011-7#3)(2011-8#7)(2011-9#9)		               	                  
		String line = value.toString();   
		/*
		*	First Pass:  Pattern##TF##NumOfWords##PatternHistory
		*/	
    	String[] OnePatternInfo = line.split("##");	 			
	
		/*
			Second Pass: Parse History (2011-1#4)(2011-10#8)(2011-11#6)(2011-12#7)(2011-2#6)(2011-3#3)(2011-4#5)(2011-5#5)(2011-6#6)(2011-7#3)(2011-8#7)(2011-9#9)		               	                  		
		*/				 			
		TreeMap <String, Integer>  MonthTFSum = new  TreeMap <String, Integer>();
		
		String[] OnePatternHistory = OnePatternInfo[3].split("\\)");
		
		for( String TFvalue : OnePatternHistory) { 
		
			if (!(TFvalue.equals(""))) {
				/*
				// Parse frequency of each time interval
				*/
				String[] Items = TFvalue.split("#"); //"(2011-1#4"				
				String TempTimeTag = Items[0].replace("\\(",""); //"2011-1"										
				String[] TimeTag = TempTimeTag.split("\\-"); 
				//String Year = TimeTag[0]; // "2011"
				String Month =TimeTag[1];// "1"			
							
				int TempTF = Integer.parseInt(Items[1]);	 // TF="4"						
				
				if (MonthTFSum.containsKey(Month)) {
					Integer Orginal = MonthTFSum.get(Month);				
					Integer sum = Orginal+TempTF;				
					MonthTFSum.put(Month,sum);				
				} else {
					MonthTFSum.put(Month,TempTF);
				} 	
			} // End of if (!(TFvalue.equals("")))
		} // End of for( String value : OnePatternHistory)
		/*
			Mapper=> Output the TF summation of each month
		*/		
		Set<String> keys = MonthTFSum.keySet();		
		Iterator<String> iterator = keys.iterator();				
		while (iterator.hasNext()) {
			String OneTimeTag = iterator.next();
			Integer Temp = MonthTFSum.get(OneTimeTag);						       								
	    	context.write(new Text(OneTimeTag), new IntWritable(Temp));	
		} // End of while (iterator.hasNext())		
		//context.write(new Text(OnePattern), new Text(OnePatternInfo[3]));				   			              			  	 	 					 			
  } // end of public void map
} // end of  public class SuffixSort
